#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#include <winnt.h>

int dec1( int *buf, int size);
int dec2( int *buf, int size);
int dec3( int *buf, int size);
int dec0( int *buf, int size);

int pr_mark = 0;

void main( int argc, char* argv[])
{
	FILE *fp;
	int bytes;
	char *buf;
	extern errno;
	int func;

	if( argc < 2){
		printf(" REMDEC PV3.DAT [0-3]\n");
		printf("    0=dump, 1=KANDEN, 2=MITSUBISHI, 3=SONY\n");
		exit( 1);
	}
	if( argc == 2)
		func = -1;
	else{
		func = atoi( argv[ 2]);
fprintf(stderr,"argc=%d\n",argc);
		if( argc > 3)
			pr_mark = 1;
	}
	if ((fp = fopen(argv[ 1], "rb")) == NULL){
		printf("fopen error %d\n", errno);
		exit(1);
	}
	fprintf(stderr, "Input File %s :", argv[1]);

	fseek( fp, 0, 2);
	bytes = ftell( fp);
	fprintf(stderr, "%d \n", bytes);
	fseek( fp, 0, 0);
	buf = VirtualAlloc( NULL, bytes, MEM_COMMIT, PAGE_EXECUTE_READWRITE);
	if( buf == NULL){
		printf("malloc error %d\n",GetLastError());
		exit(2);
	}
	fread( buf, bytes, 1, fp);
	fclose( fp);

	switch( func){
	case -1:
		dec1( (int *)buf, bytes);
		dec2( (int *)buf, bytes);
		dec3( (int *)buf, bytes);
		break;
	case 0:
		dec0( (int *)buf, bytes);
		break;
	case 1:
		dec1( (int *)buf, bytes);
		break;
	case 2:
		dec2( (int *)buf, bytes);
		break;
	case 3:
		dec3( (int *)buf, bytes);
		break;
	}

	VirtualFree( buf, bytes, MEM_DECOMMIT);
	exit(0);
}

// W,NEC,VICTOR
int dec1( int *buf, int size)
{
	int pcode, bytes, bits, loops;
	unsigned int rcode, remote[0x800/4/2];
	int count0, count, scale;
	int sp1,sp2,mk1,mk_on,mk_off,mk_sp;
	int mk_onc, mk_offc, sp_cnt;
	int titled = 0;
	for( pcode=0x400; pcode<size; pcode+=0x800){
		sp1 = buf[ pcode/4 + 1];
		mk1 = buf[ pcode/4 + 2];
		scale = buf[ pcode/4 + 3] * 2;
		mk_on = mk_off = sp2 = 0;
		mk_onc = mk_offc = sp_cnt = 0;
		for( bytes = 0; bytes<0x800/4/2; bytes++){
			rcode = 0;
			for( bits = 0; bits<8; bits++){
				count0 = buf[ pcode/4 + 3 + ( bytes*8 + bits) * 2];
				count = buf[ pcode/4 + 4 + ( bytes*8 + bits) * 2];
				if( count > scale*2){
					mk_sp = count;
					goto loopout;
				}
				if( count == 0)
					goto loopout;
				if( ( bytes == 0) && ( bits == 0)){
					if( titled == 0){
						if( pr_mark)
							printf("                                                              SPACE1   MARK1    SPACE    ON       OFF     SEPARATE\n");
						titled = 1;
					}
					printf("K : [%2X] : ", ( pcode-0x400)/0x800+1);
				}
				sp2 += count0;
				sp_cnt++;
				if( count > scale){
					rcode >>= 1;
					rcode |= 0x80;
					printf("1");
					mk_on += count;
					mk_onc++;
				}else{
					rcode >>= 1;
					printf("0");
					mk_off += count;
					mk_offc++;
				}
			}
			remote[ bytes] = rcode;
			printf(" ");
		}
loopout:
		if( bytes != 0){
			printf(": ");
			for( loops=0; loops<bytes; loops++){
				printf("%02X", remote[loops]);
				if( loops&1)
					printf(" ");
			}
			if( pr_mark){
				if( sp_cnt && mk_onc && mk_offc){
					sp2 = sp2/sp_cnt;
					mk_on = mk_on/mk_onc;
					mk_off = mk_off/mk_offc;
				}
				printf(": %08X %08X %08X %08X %08X %08X", sp1, mk1, sp2, mk_on, mk_off, mk_sp);
			}
			printf("\n");
		}
	}

	return 0;
}

// OH
int dec2( int *buf, int size)
{
	int pcode, bytes, bits, loops;
	unsigned int rcode, remote[0x800/4/2];
	int count0, count, scale;
	int sp1,mk_on,mk_off,mk_sp;
	int mk_onc, mk_offc, sp_cnt;
	int titled = 0;
	for( pcode=0x400; pcode<size; pcode+=0x800){
		scale = buf[ pcode/4 + 1] * 4;
		mk_on = mk_off = sp1 = 0;
		mk_onc = mk_offc = sp_cnt = 0;
		for( bytes = 0; bytes<0x800/4/2; bytes++){
			rcode = 0;
			for( bits = 0; bits<8; bits++){
				count0 = buf[ pcode/4 + 1 + ( bytes*8 + bits) * 2];
				count = buf[ pcode/4 + 2 + ( bytes*8 + bits) * 2];
				if( count > scale*2){
					mk_sp = count;
					goto loopout;
				}
				if( count == 0)
					goto loopout;
				if( ( bytes == 0) && ( bits == 0)){
					if( titled == 0){
						if( pr_mark)
							printf("                                       SPACE    ON       OFF     SEPARATE\n");
						titled = 1;
					}
					printf("M : [%2X] : ", ( pcode-0x400)/0x800+1);
				}
				sp1 += count0;
				sp_cnt++;
				if( count > scale){
					rcode >>= 1;
					rcode |= 0x80;
					printf("1");
					mk_on += count;
					mk_onc++;
				}else{
					rcode >>= 1;
					printf("0");
					mk_off += count;
					mk_offc++;
				}
			}
			remote[ bytes] = rcode;
			printf(" ");
		}
loopout:
		if( bytes != 0){
			printf(": ");
			for( loops=0; loops<bytes; loops++){
				printf("%02X", remote[loops]);
				if( loops&1)
					printf(" ");
			}
			if( pr_mark){
				if( sp_cnt && mk_onc && mk_offc){
					sp1 = sp1/sp_cnt;
					mk_on = mk_on/mk_onc;
					mk_off = mk_off/mk_offc;
				}
				printf(": %08X %08X %08X %08X", sp1, mk_on, mk_off, mk_sp);
			}
			printf("\n");
		}
	}

	return 0;
}

// SONY
int dec3( int *buf, int size)
{
	int pcode, bytes, bits, loops, scan;
	unsigned int rcode, remote[0x800/4/2];
	int count0, count, scale;
	int sp1,mk1,sp_on,sp_off,mk_sp;
	int sp_onc, sp_offc, mk_cnt;
	int titled = 0;
	for( pcode=0x400; pcode<size; pcode+=0x800){
		scale = 0;
		for( scan=2; scan<0x800/4; scan+=2){
			scale = buf[ pcode/4 + scan];
			if( scale > 0x10000)
				break;
		}
		if( scale == 0)
			break;
		if( scale < 0x10000){
			scan = 0;
		}
		scan++;
		scale = buf[ pcode/4 + scan] / 3;
		sp1 = buf[ pcode/4 + scan];
		scan++;
		sp_on = sp_off = mk1 = 0;
		sp_onc = sp_offc = mk_cnt = 0;
		for( bytes = 0; bytes<0x800/4/2; bytes++){
			rcode = 0;
			for( bits = 0; bits<4; bits++){
				count0 = buf[ pcode/4 + scan + ( bytes*4 + bits) * 2];
				count = buf[ pcode/4 + scan+1 + ( bytes*4 + bits) * 2];
				if( count0 > scale*2){
					mk_sp = count0;
					goto loopout;
				}
				if( count == 0)
					goto loopout;
				if( ( bytes == 0) && ( bits == 0)){
					if( titled == 0){
						if( pr_mark)
							printf("                                      SPACE1   MARK     ON       OFF     SEPARATE\n");
						titled = 1;
					}
					printf("S : [%2X] : ", ( pcode-0x400)/0x800+1);
				}
				mk1 += count0;
				mk_cnt++;
				if( count > scale){
					rcode >>= 1;
					rcode |= 0x8;
					printf("1");
					sp_on += count;
					sp_onc++;
				}else{
					rcode >>= 1;
					printf("0");
					sp_off += count;
					sp_offc++;
				}
			}
			remote[ bytes] = rcode;
			printf(" ");
		}
loopout:
		if( bytes != 0){
			printf(": ");
			for( loops=0; loops<bytes; loops++){
				printf("%01X", remote[loops]);
				printf(" ");
			}
			if( pr_mark){
				if( mk_cnt && sp_onc && sp_offc){
					mk1 = mk1/mk_cnt;
					sp_on = sp_on/sp_onc;
					sp_off = sp_off/sp_offc;
				}
				printf(": %08X %08X %08X %08X %08X", sp1, mk1, sp_on, sp_off, mk_sp);
			}
			printf("\n");
		}
	}

	return 0;
}

// f[^
int dec0( int *buf, int size)
{
	int pcode, loops;
	for( pcode=0x400; pcode<size; pcode+=0x800){
		printf("R : [%2X] : ", ( pcode-0x400)/0x800+1);
		for( loops=0; loops<0x800/4;loops++){
			if( buf[ pcode/4 + loops] == 0)
				break;
			printf("%08X ", buf[ pcode/4 + loops]);
		}
		printf("\n");
	}

	return 0;
}

